/***************************************************************************
                          CdboActionFactory.h  -  description
                             -------------------
    begin                : Sat Aug 17 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/


#ifndef CDBOACTIONFACTORY_H
#define CDBOACTIONFACTORY_H


#include <qdict.h>

#include <kaboutdata.h>
#include <kinstance.h>
#include <klibloader.h>

class CdboAction;

typedef QDict<CdboAction> ActionDict;

class CdboActionFactory : public KLibFactory
{
Q_OBJECT

public:
	CdboActionFactory( QObject* parent = 0, const char* name = 0 );
	virtual ~CdboActionFactory();

	virtual QObject*  createObject ( QObject* parent = 0, const char* name = 0,
			const char* classname = 0, const QStringList &args = QStringList() ) ;

	CdboAction* createAction(QString classname, QString name = QString::null);
	
	static const KAboutData *aboutData();
	static KInstance *instance();

public slots:
	void actionDone(CdboAction*);


protected:
	ActionDict actionDict;
	
private:
	static KInstance *mInstance;
	static KAboutData *mAboutData;
};


#endif
