/***************************************************************************
                          CdboCopyCdAction.h  -  description
                             -------------------
    begin                : Sun Sep 1 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/
#ifndef CDBOCOPYCDTION_H
#define CDBOCOPYCDTION_H

#include "CdboAction.h"

class KProcess;

////////////
class CdboCopyCdAction : public CdboActionHandler{
	Q_OBJECT

public:
	CdboCopyCdAction(KLibFactory* factory, QObject *, const char *);
	~CdboCopyCdAction();

protected slots:
	void curProcDoneSlot(KProcess *);
	void receivedCountAudioMessageSlot(KProcess *, char *, int);

protected:
	virtual void initProcess(KProcess *proc, CdboParamsDict* params);
	virtual void processFailed();
	virtual void processSucceded();
	virtual void resetSettings();
	
	void countAudioTracks(const QString &device);

private:
	bool withCleanUp;
	bool readOnly;
	bool gotAnswer;
	bool waitingForProcess;
	
	QStringList filesToCleanup;
	
	QString isoImageName;
	QString tocName;
	QString convertedNamesHolder;
	QString pickedTracksListHolder;
	QString cdrdaoMode;
	
	int totalTracks;
};

#endif
