/***************************************************************************
                          CdboReadDataCdAction.h  -  description
                             -------------------
    begin                : Fri Aug 16 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOREADDATACDACTION_H
#define CDBOREADDATACDACTION_H


#include "CdboAction.h"

class KProcess;

class CdboReadDataCdAction : public CdboAction{
	Q_OBJECT

public:
	CdboReadDataCdAction(QObject*, const char *);
	~CdboReadDataCdAction();

	virtual bool filterOutput(int &type, QString &message);
	
protected:
	virtual void initProcess(KProcess *proc, CdboParamsDict* params);
	virtual void processLaunched();
	virtual void processFailedToLaunch();
	virtual void processSucceded();
	virtual void processFailed();

private:
	void initReadcdProcess(KProcess *proc, QString &device, QString &isoImageName, bool noError);
	void initDdProcess(KProcess *proc, QString &device, QString &isoImageName);
	
	int totalToDo;
	bool usingReadcd;
	QString prevMessage;
	bool showedFixingErrorMess;
	int plCount;
};
#endif
