/***************************************************************************
                          CdboCopyCDBase.h  -  description
                             -------------------
    begin                : Sat May 5 2002
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOCOPYCDBASE_H
#define CDBOCOPYCDBASE_H

#include <ktabctl.h>

#include "CdboDialogBase.h"

class QVBoxLayout; 
class QHBoxLayout;
class QGridLayout; 
class CdboDialogCntPnl;
class CdboDriveInfoPnl;
class QButtonGroup;
class QCheckBox;
class QComboBox;
class QGroupBox;
class QLabel;
class QListView;
class QListViewItem;
class QPushButton;
class QRadioButton;
class QSpinBox;
class QTabWidget;
class QWidget;
class CdboSpeedPnl;

class CdboCopyCDBaseTabs;
class CdboCddaView;

class CdboCopyCDBase : public CdboDialogBase
{ 
    Q_OBJECT

public:
    CdboCopyCDBase( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~CdboCopyCDBase();

protected:
    CdboDialogCntPnl* dialogCntPnl;
    QWidget* baseFrm;
    CdboDriveInfoPnl* srcDevicePnl;
    CdboDriveInfoPnl* targetDevicePnl;
    CdboCopyCDBaseTabs* detailsTab;
    QWidget* detailsFrm;
    QGroupBox* readDetailsPnl;
	QLabel* typeLbl;
    QComboBox* typeCmb;
    QCheckBox* removeTmpChk;
    QGroupBox* recordDetailesPnl;
    QComboBox* actionCmb;
    QLabel* numOfCopiesLbl;
    QSpinBox* numberSpn;
    CdboSpeedPnl* speedPnl;
    QWidget* audioTb;

    QVBoxLayout* baseFrmLayout;
    QVBoxLayout* detailsFrmLayout;
    QHBoxLayout* readDetailsPnlLayout;
    QHBoxLayout* recordDetailesPnlLayout;
    QVBoxLayout* cdTypePnlLayout;
    QVBoxLayout* audioTbLayout;

     CdboCddaView *trackView;
};

class CdboCopyCDBaseTabs : public KTabCtl{
    Q_OBJECT
public:
	CdboCopyCDBaseTabs( QWidget* parent = 0, const char* name = 0);
	void showAudioTab(){ showTab(1); }
};
#endif
