/***************************************************************************
                          CdboDialogFactory.h  -  description
                             -------------------
    begin                : Fri Aug 23 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBODIALOGFACTORY_H
#define CDBODIALOGFACTORY_H

#include <qdict.h>

#include <kaboutdata.h>
#include <kinstance.h>
#include <klibloader.h>

class KDialog;
class KCmdLineArgs;

typedef QDict<KDialog> DialogDict;

class CdboDialogFactory : public KLibFactory
{
Q_OBJECT

public:
	CdboDialogFactory( QObject* parent = 0, const char* name = 0 );
	virtual ~CdboDialogFactory();

	virtual QObject*  createObject ( QObject* parent = 0, const char* name = 0,
			const char* classname = 0, const QStringList &args = QStringList() ) ;

	KDialog* createDialog(const char* classname, QWidget* parentWidget = 0,
		const char* name = 0, const QStringList &args = QStringList() );


	void loadArgs(KCmdLineArgs *args);
	
	static const KAboutData *aboutData();
	static KInstance *instance();

public slots:
	void dialogDone(KDialog* dialog);

protected slots:
	void processArgs();
	
protected:
	bool processCdboDialogArgs(KDialog* dialog);
	void processCdboDataCDDialogArgs(KDialog* dialog);
	bool processCdboAudioCDDialogArgs(KDialog* dialog);
	
private:
	static KInstance *mInstance;
	static KAboutData *mAboutData;

	DialogDict dialogDict;
	KCmdLineArgs *args;
};


#endif

