/***************************************************************************
                          CdboEraseCDBase.h  -  description
                             -------------------
    begin                : Sat May 5 2001
    copyright            : (C) 2001 by Alexy Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/
/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOERASECDBASE_H
#define CDBOERASECDBASE_H

#include <qvariant.h>

#include "CdboDialogBase.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class CdboDialogCntPnl;
class CdboDriveInfoPnl;
class QCheckBox;
class QComboBox;
class QFrame;
class QGroupBox;
class CdboSpeedPnl;
class QPushButton;

class CdboEraseCDBase : public CdboDialogBase{
	Q_OBJECT

public:
	CdboEraseCDBase( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);
	CdboEraseCDBase(bool eraseMode, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);
	~CdboEraseCDBase();

protected:
	void init();
	CdboDialogCntPnl* dialogCntPnl;
	QFrame* baseFrm;
	CdboDriveInfoPnl* targetDevicePnl;
	QFrame* detailsFrm;
	QGroupBox* optPnl;
	QComboBox* blankTypeCmb;
	QCheckBox* forceChk;
	CdboSpeedPnl* speedPnl;
	QGridLayout* cdboEraseBaseLayout;
	QHBoxLayout* optPnlLayout;
	
private:
	bool eraseMode;
	QVBoxLayout* baseFrmLayout;
	QVBoxLayout* detailsPnlLayout;
};

#endif
