/***************************************************************************
                          CdboTmpDirConfig.h  -  description
                             -------------------
    begin                : Fri Jun 1 2001
    copyright            : (C) 2001 by Alexy Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOTMPDIRCONFIG_H
#define CDBOTMPDIRCONFIG_H


#include "CdboTmpDirConfigBase.h"
class KProcess;
class KConfig;

class CdboTmpDirConfig : public CdboTmpDirConfigBase
{
    Q_OBJECT

public:
	CdboTmpDirConfig( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	~CdboTmpDirConfig();
	
	void readOptions();
	void saveOptions();
	bool bigEnouphTmp();
	
public slots:
	void checkTmpSize();
	void enableErrorMessage();
	void disableErrorMessage();
	void defaults();
	
signals:
	void modified();
	
protected slots:
	virtual void checkSizeSlot();
	virtual void tmpBrowseSlot();
	void kcmshellDone(KProcess *proc);
	void receivedSizeMessageSlot(KProcess *proc, char *buffer, int buflen);
	void slotChanged();
	void updateSizeInfoLbl();

protected:
	void updateTmp();
	
private:
	KConfig* config;
	QString tempDir;
	bool showMessage;
	bool showBrowseError;
	int tmpSize;
};

#endif //CDBOTMPDIRCONFIG_H
