/***************************************************************************
                          CdboToolsList.h  -  description
                             -------------------
    begin                : Fri Jul 14 2002
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOTOOLSLIST_H
#define CDBOTOOLSLIST_H

#include <kinstance.h>
#include "CdboToolsListBase.h"

class CdboToolsList : public CdboToolsListBase
{
	Q_OBJECT

public:
	CdboToolsList( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	~CdboToolsList();
	
	void saveOptions();
	void initToolsToFixList(QStringList &list);
	static KInstance *instance();

public slots:
	void scanTools();
	void loadSavedTools();
		
signals:
	void modified();
	
protected slots:
	virtual void toolsApplySlot();
	virtual void toolsBrowseSlot();
	void rescanTools();
	void dumpToolsSlot();
	void launchToolHomepage();

	virtual void toolActivatedSlot(QListViewItem *);
	void popupToolsMenuSlot(QListViewItem *, const QPoint &, int);
	

protected:
	void populateTools(bool loadPrevPath);
	void initSingleTool(const QString &name, const QString &description, const QString &homePage = QString::null, const QString &path = QString::null);
	void checkTool(QListViewItem * item, QString path=QString::null);
	
private:
	static KInstance *mInstance;
	QPopupMenu *toolMenu;
	int thpIndex;
	
	QStringList toolsToFixList;
};

#endif //CDBOTOOLSLIST_H
