/***************************************************************************
                          CdboWizard.h  -  description
                             -------------------
    begin                : Fri Jul 14 2002
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOWIZARD_H
#define CDBOWIZARD_H

#include <dcopobject.h>
#include "CdboWizardBase.h"

class QPixmap;
class KProcess;
class KConfig;
class QCloseEvent;
class QPopupMenu;

class CdboWizard : public CdboWizardBase, public DCOPObject
{
    Q_OBJECT
    K_DCOP

public:
	CdboWizard( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~CdboWizard();

	void save();
	void load();

k_dcop:
	void setupToolAcknowledgedInstance();
	void output(QString);
	void toolDone(QString, QString);

protected slots:
	void initJobInfo();
	virtual void lunchSettingsSlot();
	virtual void permGrpChkSlot();
	virtual void next();
	virtual void back();
	virtual void permApplySlot();
	void checkDevices();
	void pickActiveGroup();
	void checkFstab();

	void dumpOutputSlot();
	void popupOutputMenuSlot(QListViewItem *, const QPoint &, int);

	void kcmshellDone(KProcess *proc);

	void initUserInfo();
	void receivedUserInfoMessageSlot(KProcess *, char *buffer, int buflen);
	void initUserGroupsNames();

	virtual void accept ();
	virtual void reject ();
	virtual void closeEvent(QCloseEvent *e);
	virtual void help ();


protected:
	void initReqiredActions();

private:
	QPixmap *sidePix;
	QPopupMenu *outputMenu;

	KConfig *config;
	KProcess *cdboProc;
	void initPix();

	int currPage;
	int deepestPage;

	QString userId;
	QString userName;
	QString pickedActiveGroup;

	QStringList userGroups;
	QStringList userGroupsNames;//for search

	QStringList devicesToFixList;
	QStringList missingFstabList;
	QStringList toolsToFixList;

	QStringList mountPointsList;

};

#endif // CDBOWIZARD_H
