/***************************************************************************
                          cdbosetuptool.h  -  description
                             -------------------
    begin                : Tue Jul 16 10:22:34 EDT 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sf.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOSETUPTOOL_H
#define CDBOSETUPTOOL_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapplication.h>
#include <dcopobject.h>
#include <qwidget.h>

class KShellProcess;
class KProcess;

class CdboSetupTool : public QWidget, public virtual DCOPObject
{
	Q_OBJECT
public:
	CdboSetupTool(QWidget* parent=0, const char *name=0);
	~CdboSetupTool();

	bool process(const QCString &fun, const QByteArray &data, QCString&, QByteArray &);

protected slots:
	void verifyInstance();
	void receivedVerifyInstanceMessageSlot(KProcess *, char *buffer, int buflen);
	void kcmshellDone(KProcess *);

	void acknowledgeInstance();
	void done(bool);

	void begin();
	//void initJobInfo(QString);
	void output(QString);

	bool createNewGroup();
	bool backupGroupFile();
	void backupGroupDone(KProcess *);

	bool makeToolUsable();
	void makeToolUsableDone(KProcess *);

	bool addFstabEntries();
	bool backupFstab();
	void backupFstabDone(KProcess *);

	bool makeDeviceReadable();
	void makeDeviceReadableDone(KProcess *);

	bool applyGroupToUse(QString);
	void applyGroupToUseDone(KProcess *);


protected:
	KShellProcess *cdboProc;

	QString userId;
		QString userName;

	bool inforceGroup;
	QString groupToUse;
	bool newGroup;

	QStringList devicesToFixList;
	QStringList missingFstabList;
	QStringList toolsToFixList;

	bool groupFileBackedup;
	bool fstabBackedup;

	bool restartRequired;
	bool hasFstabModifyOnly;

};

#endif
