/***************************************************************************
                          CdboShell.h  -  description
                             -------------------
    begin                : Sat Oct 19 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef _CDBOSHELL_H_
#define _CDBOSHELL_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <kparts/mainwindow.h>
#include <dcopobject.h>
 
class QLabel;

class KConfig;
class KProgress;
class KParts::PartManager;

class CdboMainView;


class CdboShell : public KParts::MainWindow, public virtual DCOPObject
{
    Q_OBJECT
public:
	CdboShell( const char *name=0);
	virtual ~CdboShell();

	void load(const KURL& url);

	void replugNewViewAction();
	void plugNewViewAction();
	void unplugNewViewAction();
	void plugIntoNewViewAction(KAction* action);
	void unplugFromNewViewAction(KAction* action);

	KParts::PartManager* partManager() { return m_partManager; }

public slots:
	void slotSetStatusBarText(const QString &text);
	void newType(const QString &type);
	void slotSetCaption(const QString &newCaption, bool modified);
	void updateProgress(int value);

protected:
	void saveOptions();
	void readOptions();
	virtual bool queryClose();
	virtual bool queryExit();

private slots:
	void optionsShowStatusbar();
	void optionsConfigureKeys();
	void optionsConfigureToolbars();
	void slotNewToolbarConfig();
	void slotFileOpenRecent(const KURL& url);
	void slotFileOpen();
	void slotFileQuit();

private:
	void setupActions();
	void initStatusBar();

private:
	CdboMainView *mainView;
	KConfig *config;
	KParts::PartManager* m_partManager;

	QLabel *status;
	QLabel *info;
	KProgress *progress;

	KRecentFilesAction* fileOpenRecent;
	KActionMenu* newViewMenuAction;
	KToggleAction *showStatusbarAction;
	KAction* closeAction;
};

#endif // _CDBOSHELL_H_
