/***************************************************************************
                          cdbo_konqy_plugins.h  -  description
                             -------------------
    begin                : Wed Sep 4 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBO_KONQY_PLUGINS_H
#define CDBO_KONQY_PLUGINS_H

#include <kparts/plugin.h>
#include <klibloader.h>
#include <kaction.h>

class KonqDirPart;
class KProcess;

class CdboKonqyPlugins : public KParts::Plugin{
Q_OBJECT
public:
	CdboKonqyPlugins( QObject* parent, const char* name, const QStringList & );
	virtual ~CdboKonqyPlugins() {}

protected slots:
	void updateActions();
	void newCDPropertiesSlot();
	void createISOSlot();
	void burnThisCDSlot();
	void launchWizardSlot();
	void kcmshellDone(KProcess *proc);
      
protected:
	KonqDirPart* parentPart() const;
	void enableActions(bool doIt);
	void launchCommand(const QString& command);
	
	KAction* newCDProperties;
	KAction* createISO;
	KAction* burnThisCD;
};

#endif
