/***************************************************************************
                          CdboAudioViewPart.h  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sf.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOAUDIOVIEWPART_H
#define CDBOAUDIOVIEWPART_H

#include <kparts/part.h>
#include <kparts/browserextension.h>
#include <kparts/genericfactory.h>

#include "CdboViewPart.h"


class QListViewItem;
class KAboutData;
class CdboAudioEstimate;
class CdboAudioListView;
class CdboPlayerPnl;

class CdboAudioViewPart : public CdboViewPart{
Q_OBJECT
public:
	CdboAudioViewPart( QWidget *parentWidget, const char *widgetName,
                  QObject *parent, const char *name=0, const QStringList& args = QStringList());
	virtual ~CdboAudioViewPart();
    
	static KAboutData* createAboutData();

public slots:
	virtual bool openFile();
	virtual void addItems(KURL::List &urls);
	virtual void readOptions();
	
protected slots:
	void dropOcurred(QDropEvent * e, QListViewItem *);
	
protected:
	void setupActions();
	virtual void createCD();
	bool canAccept(const KURL &url);
	virtual bool isEmpty();
	virtual void saveToFile(KConfig *);
	
	void saveOptions();

private:
	CdboAudioEstimate *estimate;
	CdboAudioListView* listView;
	CdboPlayerPnl* player;
};


typedef KParts::GenericFactory<CdboAudioViewPart> CdboAudioViewFactory;

/**
 * A mysterious class, needed to make Konqueror intrgration work.
 */
class CdboAudioViewBrowserExtension : public KParts::BrowserExtension{

	Q_OBJECT

public:
	CdboAudioViewBrowserExtension( CdboAudioViewPart * );
	~CdboAudioViewBrowserExtension();
};

#endif

