/***************************************************************************
                          CdboCddaView.h  -  description
                             -------------------
    begin                : Sun Feb 3 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOCDDAVIEW_H
#define CDBOCDDAVIEW_H

#include <qframe.h>

class QVBoxLayout;
class QListViewItem;

class KListView;
class KActionCollection;
class KActionMenu;

class CdboPlayerPnl;

class CdboCddaView : public QFrame
{
    Q_OBJECT

public:
    CdboCddaView( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~CdboCddaView();

	void load(QString tracks, bool uncheck = true);

	void setHeaderClickEnabled(bool);
	void setRenameable();
	void showLongTitle();

	bool getPickedTracks(QStringList* );
	void setShowSize();

signals:
	void reloadTracks();

public slots:
	void invalidate();
	void stop();
	void previewSlot();

protected slots:
	void reload();
	void popupMenuSlot(QListViewItem*, const QPoint&, int);
	void slotCheckAll();
	void slotUncheckAll();
	void slotSelectFile(QListViewItem *);

protected:
	void setupActions();

private:
	QVBoxLayout* layout;
	KListView *trackView;
	CdboPlayerPnl *player;

	KActionCollection* actionCollection;
	KActionMenu* actionMenu;
	bool renameable;
	bool showingSize;
};

#endif
