/***************************************************************************
                          CdboComOutDialog.h  -  description
                             -------------------
    begin                : Fri Jun 1 2001
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOCOMOUTDIALOG_H
#define CDBOCOMOUTDIALOG_H

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QFrame;
class QListViewItem;
class QPushButton;
class QPopupMenu;

class KListView;

class KShellProcess;
class KProcess;

class CdboComOutDialog : public QDialog{
    Q_OBJECT

public:
    	CdboComOutDialog( QWidget* parent = 0, const char* name = 0, bool modal = true );
    	~CdboComOutDialog();


public slots:
	void append(QString);
	void getScsiDetailes(QString);
	void getCDDetailes(QString);
	void unlockCD(QString);
	void slotReload();

protected slots:
	void dumpSlot();
	void quitSlot();
	void popupMenuSlot(QListViewItem *, const QPoint &, int);


	void processDoneSlot(KProcess *proc);
	void receivedMessageSlot(KProcess *proc, char *buffer, int buflen);

private:
	QPopupMenu *menu;

	QVBoxLayout* layout;
	KListView* outputView;
	QFrame* line;
	QPushButton* closeBtn;

	KShellProcess *cdboProc;
	bool doIt;
	bool visible;
	QString lastDevice;
	int lastOperation;

};

#endif
