/***************************************************************************
                          CdboComOutListView.h  -  description
                             -------------------
    begin                : Thu May 31 2001
    copyright            : (C) 2001 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOCOMOUTLISTVIEW_H
#define CDBOCOMOUTLISTVIEW_H

#include <qdict.h>

#include <klistview.h>

class KConfig;
class QPopupMenu;

class CdboProgressItem;

class CdboComOutListView : public KListView{
    Q_OBJECT

public:
	CdboComOutListView( QWidget* parent = 0, const char* name = 0 );
	~CdboComOutListView();

	void readOptions();
	void saveOptions();
	void clearOutput();

signals:
	void outputDirty();
	
public slots:
	void output(int type, QString message);
	void percent(QString procId, int percentVal, QString optMess = QString::null);
	void percentInfo(QString procId, QString message);
	bool dumpSlot();
	void dumpAsSlot();

protected slots:
	void popupMenuSlot(QListViewItem *, const QPoint &, int);

protected:
	void updateProgress(int,QListViewItem *, QString optMess = "");
	/**
     * Reinitializes configuration file. Will use cdbakeoven's one
     * by default, override to point to a different config.
     */
	virtual void resetConfig();

private:
	void initByType(int type, QString *mtype, QString *pixmap);
	void processMinimumOutMess(int,QString);
	void processFullOutMess(int,QString);
	
	KConfig *config;
	QPopupMenu *menu;
	QDict<CdboProgressItem> progressDict;
	QListViewItem *buttomItem;
	QListViewItem *prevItem;
	
	bool minimumOut;
	QString lastLogFile;
};

#endif
