/***************************************************************************
                          CdboPlayerPnl.h  -  description
                             -------------------
    begin                : Wed Jan 30 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/

#ifndef CDBOPLAYERPNL_H
#define CDBOPLAYERPNL_H


#include <kmediaplayer/player.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QFrame;
class QLabel;
class QPushButton;
class QTimer;

class KActionMenu;
class KToggleAction;

class CdboPlayerPnl : public QWidget
{
	Q_OBJECT

public:
	CdboPlayerPnl( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	virtual ~CdboPlayerPnl();

	KURL currentUrl();
	void saveOptions();
	void readOptions();
	void setupActions(KActionCollection* actionCollection);

public slots:
	void playURLs(KURL::List &urls);
	void playURL(const KURL &url);
	void stop();
	
signals:
	void emptyPlayRequested();
	void nextRequested();
	void prevRequested();
	void songDone();
	
protected slots:
	void play();
	bool openURL(const KURL &);
	void stateChangedSlot(int);
	void forward();
	void back();
	void emptySlot(){}
	void prev();
	void next();
	void updateTime();
	void slotShowPlayer();

protected:
	void reset();
	
private:
	bool loadKaboodle();
	QString timeString(unsigned long time);
	
	 KMediaPlayer::Player* kaboodle;
	QTimer *ticker;
	KToggleAction* showPlayerAction;
	KToggleAction* loopAction;
	KURL::List urlsToPlay;
	int playIndex;
	bool stoped;
	bool exceptRequests;
	
	
	QHBoxLayout* CdboPlayerPnlLayout;
	QHBoxLayout* cntPnlLayout;

	QFrame* cntPnl;
	QPushButton* playBtn;
	QPushButton* stopBtn;
	QPushButton* forwardBtn;
	QPushButton* backBtn;
	QPushButton* prevBtn;
	QPushButton* nextBtn;
	QLabel *timeLbl;
	QLabel *curLbl;
};

#endif // CDBOPLAYERPNL_H
