/***************************************************************************
                          CdboViewWidgetBase.h  -  description
                             -------------------
    begin                : Sat Oct 21 2002
    copyright            : (C) 2002 by Alex Podolsky
    email                : alexpod@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; see the file COPYING.  If not, write to
	the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.

***************************************************************************/ 

#ifndef CDBOVIEWWIDGETBASE_H
#define CDBOVIEWWIDGETBASE_H

#include <qframe.h>

#include "CdboExpandPnl.h"

class QGridLayout;
class KActionCollection;

class CdboViewWidgetBase : public QFrame{
  Q_OBJECT
public:
    CdboViewWidgetBase(QWidget *parent = 0, const char *name=0);
    ~CdboViewWidgetBase();
	 
	QWidget * getListViewHolder() { return listViewHolder; }
	void plugView(QWidget *listView);
	QWidget * getEstimateHolder() { return estimateHldr; }
	void plugEstimate(QWidget *estimate, bool show = true);
	
	void readOptions(KConfig* config = 0);
	void saveOptions(KConfig* config = 0);
	
	KActionCollection* getActionCollection() { return actionCollection; }

public slots: 
	void resetCursor();
	void setWaitCursor();
	
protected slots:
	void showEstimate();

protected:
	void setupActions();

private:
	QGridLayout *mainLayout;
	KActionCollection *actionCollection;
	KToggleAction* showEstimateAction;
	
	QFrame* listViewHolder;
	CdboExpandPnl* estimateHldr;
};

#endif // CDBOVIEWWIDGETBASE_H
